// This is the main project file for VC++ application project 
// generated using an Application Wizard.

#include "stdafx.h"

#using <mscorlib.dll>
#include "windows.h"

using namespace System;
using namespace System::Runtime::InteropServices;
using namespace System::Text;

#define		BOOL					int
#define		TRUE					1
#define		FALSE					0

#define	    COMPRESSION_NONE		1	/* dump mode */
#define	    COMPRESSION_CCITTRLE	2	/* CCITT modified Huffman RLE */
#define	    COMPRESSION_CCITTFAX3	3	/* CCITT Group 3 fax encoding */
#define	    COMPRESSION_CCITTFAX4	4	/* CCITT Group 4 fax encoding */
#define	    COMPRESSION_LZW		5       /* Lempel-Ziv  & Welch */
#define	    COMPRESSION_JPEG		7	/* %JPEG DCT compression */
#define	    COMPRESSION_PACKBITS	32773	/* Macintosh RLE */

[DllImport("pdf2image.dll", CharSet=CharSet::Auto)]
extern "C" unsigned int PDFToImageConverter(char *FileName, char *OutputName,
	const char *UserPassword, const char *OwnPassword,
	int xresolution, int yresolution, int bitcount, 
	int compression, int quality, int grayscale, 
	int multipage,  int firstPage, int lastPage);

void ConvertStringToPointer(String* TheString, char *buf, int buflen)
{
	IntPtr ip = Marshal::StringToHGlobalAnsi(TheString);
	const char* str = static_cast<const char*>(ip.ToPointer());
	strncpy(buf, str, buflen);
	buf[buflen - 1] = '\0';
	Marshal::FreeHGlobal(ip);
}

int ConvertFile(String *NameIn, String *NameOut)
{
	StringBuilder *sb = new StringBuilder(4096);
	sb->Append("Converting: ");
	sb->Append(NameIn);
	sb->Append(" to ");
	sb->Append(NameOut);
	Console::WriteLine(sb->ToString());

	int RetVal = -1;
	try
	{
		const char *UserPassword = NULL;
		const char *OwnPassword = NULL;
		int xRes = 200;
		int yRes = 200;
		int bitcount = 24;
		int compression = COMPRESSION_CCITTFAX4;
		int quality = 70;
		BOOL grayscale = FALSE;
		BOOL multipage = TRUE;
		int FirstPage = -1;
		int LastPage = -1;

		const int c_MaxFileName = 256;
		char cNameIn[c_MaxFileName];
		char cNameOut[c_MaxFileName];

		ConvertStringToPointer(NameIn, cNameIn, c_MaxFileName);
		ConvertStringToPointer(NameOut, cNameOut, c_MaxFileName);

		RetVal = PDFToImageConverter(cNameIn, cNameOut, UserPassword, OwnPassword,
			xRes, yRes, bitcount, compression, quality, grayscale, multipage, FirstPage, LastPage);
	}
	catch (Exception *ex)
	{
		Console::WriteLine(ex->Message);
	}
	return RetVal;
}

int _tmain()
{
	String *SourceFile = "C:\\DoesntWork.pdf";
	String *DestFile = "C:\\temp.tif";

	StringBuilder *sb = new StringBuilder(4096);
	sb->Append("IJW, converting ");
	sb->Append(SourceFile);
	sb->Append(" to ");
	sb->Append(DestFile);
	Console::WriteLine(sb->ToString());

	if (sb->Length > 0)
		sb->Remove(0, sb->Length);
	try
	{
		int RetVal = ConvertFile(SourceFile, DestFile);
		sb->Append("Returned: ");
		sb->Append(RetVal.ToString());
	}
	catch (Exception *ex)
	{
		sb->Append("Exception: ");
		sb->Append(ex->Message);
	}

	sb->Append(", press enter...");
	Console::Write(sb->ToString());
	Console::ReadLine();
	return 0;
}
